diff --strip-trailing-cr -Nur gnutls-2.10.5.orig/lib/gnutls_int.h gnutls-2.10.5/lib/gnutls_int.h
--- gnutls-2.10.5.orig/lib/gnutls_int.h	2010-09-26 21:34:09 +0800
+++ gnutls-2.10.5/lib/gnutls_int.h	2011-04-06 17:03:30 +0800
@@ -43,6 +43,11 @@
 typedef int ssize_t;
 #endif
 
+/*
+mingw64 ssize_t is not int?
+*/
+#define ssize_t int
+
 #include <sys/types.h>
 #include <unistd.h>
 #include <sys/stat.h>
diff --strip-trailing-cr -Nur gnutls-2.10.5.orig/libextra/gnutls_openssl.c gnutls-2.10.5/libextra/gnutls_openssl.c
--- gnutls-2.10.5.orig/libextra/gnutls_openssl.c	2010-08-02 04:37:30 +0800
+++ gnutls-2.10.5/libextra/gnutls_openssl.c	2011-04-06 17:04:19 +0800
@@ -35,6 +35,13 @@
    name, so restore the original name. */
 #undef shutdown
 
+/*
+mingw64 already define X509_NAME in wincrypt.h
+*/
+#ifdef X509_NAME
+#undef X509_NAME
+#endif
+
 /* XXX: See lib/gnutls_int.h. */
 #define GNUTLS_POINTER_TO_INT(_) ((int) GNUTLS_POINTER_TO_INT_CAST (_))
 #define GNUTLS_INT_TO_POINTER(_) ((void*) GNUTLS_POINTER_TO_INT_CAST (_))
diff --strip-trailing-cr -Nur gnutls-2.10.5.orig/libextra/includes/gnutls/openssl.h gnutls-2.10.5/libextra/includes/gnutls/openssl.h
--- gnutls-2.10.5.orig/libextra/includes/gnutls/openssl.h	2010-08-02 04:37:30 +0800
+++ gnutls-2.10.5/libextra/includes/gnutls/openssl.h	2011-04-06 17:04:38 +0800
@@ -92,6 +92,13 @@
 #define SSL_MODE_ACCEPT_MOVING_WRITE_BUFFER (0x2)
 #define SSL_MODE_AUTO_RETRY (0x4)
 
+/*
+mingw64 already define X509_NAME in wincrypt.h
+*/
+#ifdef X509_NAME
+#undef X509_NAME
+#endif
+
   typedef gnutls_x509_dn X509_NAME;
   typedef gnutls_datum_t X509;
 
